package jboudny.olympiada;

import java.awt.Color;

import org.lwjgl.opengl.GL11;

public class DisplayListBuilder {

	public static int genDL(Tower t) {
		int i = GL11.glGenLists(1);
		
		GL11.glNewList(i, GL11.GL_COMPILE);
		
		GL11.glBegin(GL11.GL_QUADS);
	    
		for (Block b : t.blocks) {
	    	addCuboid(b.x-1, b.x+b.w-1, b.y-1, b.y+b.h-1, b.layer-1, b.c);
	    }
		
		GL11.glEnd();
		
		GL11.glEndList();
		
		return i;
	}
	
	public static void addCuboid(int x0, int x1, int y0, int y1, int l, Color c) {
		
		GL11.glColor3f(c.getRed()/255f, c.getGreen()/255f, c.getBlue()/255f);
		
		GL11.glVertex3f(x0, l, y0);
		GL11.glVertex3f(x1, l, y0);
		GL11.glVertex3f(x1, l, y1);
		GL11.glVertex3f(x0, l, y1);
		
		GL11.glVertex3f(x0, l+1, y0);
		GL11.glVertex3f(x1, l+1, y0);
		GL11.glVertex3f(x1, l+1, y1);
		GL11.glVertex3f(x0, l+1, y1);
		
		GL11.glVertex3f(x0, l, y0);
		GL11.glVertex3f(x1, l, y0);
		GL11.glVertex3f(x1, l+1, y0);
		GL11.glVertex3f(x0, l+1, y0);
		
		GL11.glVertex3f(x0, l, y1);
		GL11.glVertex3f(x1, l, y1);
		GL11.glVertex3f(x1, l+1, y1);
		GL11.glVertex3f(x0, l+1, y1);
		
		GL11.glVertex3f(x0, l, y0);
		GL11.glVertex3f(x0, l, y1);
		GL11.glVertex3f(x0, l+1, y1);
		GL11.glVertex3f(x0, l+1, y0);
		
		GL11.glVertex3f(x1, l, y0);
		GL11.glVertex3f(x1, l, y1);
		GL11.glVertex3f(x1, l+1, y1);
		GL11.glVertex3f(x1, l+1, y0);
		
	}
	
}
