package jboudny.olympiada;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;

import javax.swing.JPanel;

public class LayerPanel extends JPanel{

	public Tower t;
	public int layer;
	
	public LayerPanel(Tower t, int layer) {
		this.t = t;
		this.layer = layer;
	}
	
	@Override
	public void paint(Graphics arg0) {
		super.paint(arg0);
		
		Graphics2D g2d = (Graphics2D) arg0;
		
		int maxSize = Math.max(t.x, t.y);
		
		int tileSize = Math.max(this.getWidth(), this.getHeight()) / maxSize/2;
		
		for (Block b : t.blocks) {
			if (b.layer == this.layer) {
				g2d.setColor(b.c);
				g2d.fillRect((b.x-1)*tileSize, (b.y-1)*tileSize,b.w*tileSize, b.h*tileSize);
			}
		}
		
		for (Block b : t.blocks) {
			if (b.layer == this.layer) {
				g2d.setColor(Color.BLACK);
				g2d.drawRect((b.x-1)*tileSize, (b.y-1)*tileSize,b.w*tileSize, b.h*tileSize);
			}
		}
		
	}
	
}
